#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <string>
#include <queue>
#include <map>
#include <limits>
#include <set>
#include <algorithm>

using namespace std;

long long int plane_sum[3];
long long int str_sum[3][2][1001];
int sz;

void add()
{
	int plane_ind, cord[2], val;
	cin >> plane_ind >> cord[0] >> cord[1] >> val;
	plane_ind--;
	plane_sum[plane_ind] += val;
	if (plane_ind == 1)
		swap(cord[0], cord[1]);
	str_sum[plane_ind][0][cord[0]] += val * sz;
	str_sum[plane_ind][1][cord[1]] += val * sz;
}

long long int get_sum()
{
	int plane_ind, cord;
	cin >> plane_ind >> cord;
	plane_ind--;
	int i1 = 0, i2 = 0;
	if (plane_ind == 1)
		i1 = 0, i2 = 0;
	else
		if (plane_ind == 2)
			i1 = 1, i2 = 1;
		else
			i1 = 0, i2 = 1;
	long long int res = plane_sum[plane_ind] + str_sum[(plane_ind + 1) % 3][i1][cord] + str_sum[(plane_ind + 2) % 3][i2][cord];
	return res;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int N;
	cin >> sz >> N;
	for (int i = 0; i < N; i++)
	{
		int com_type;
		cin >> com_type;
		if (com_type == 1)
			add();
		if (com_type == 2)
			cout << get_sum() << ' ';
	}
}
